package wpd

import (
	"context"
	"os"
	"testing"
	"time"

	"github.com/stretchr/testify/assert"
	"github.com/stretchr/testify/require"

	"orus.io/orus-io/rednerd/testutils"
)

func TestRealWpd(t *testing.T) {
	log := testutils.GetLogger(t)
	p, err := NewRealProcess()

	require.NoError(t, err)
	ctx, cancel := context.WithTimeout(context.Background(), time.Second*5)
	defer cancel()

	wpd, err := NewProcessWPD(p, log)
	require.NoError(t, err)

	id, err := wpd.Submit(ctx, "", []byte("<p>A small paragraph</p>"))
	require.NoError(t, err)

	rid, c, err := wpd.NextResult()
	require.NoError(t, err)
	assert.Equal(t, id, rid)
	assert.NotZero(t, len(c))

	assert.NoError(t, os.WriteFile(t.Name()+".pdf", c, 0o600))

	assert.NoError(t, p.Stop())
}
