// Code generated by go-swagger/go-orusapi; DO NOT EDIT.

// Copyright Orus.io team

package auth

import (
	"net/http"

	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promhttp"
)

var (
	refreshTokenHandlerDuration = prometheus.NewSummaryVec(
		prometheus.SummaryOpts{
			Name:       "orus_api_handler",
			Help:       "The handlers duration and count.",
			Objectives: map[float64]float64{0.9: 0.01, 0.95: 0.01, 0.99: 0.001},
			ConstLabels: map[string]string{
				"service": "refresh-token",
				"tag":     "[auth]",
			},
		},
		[]string{"code"},
	)

	refreshTokenHandlerInFlight = prometheus.NewGauge(
		prometheus.GaugeOpts{
			Name: "orus_api_handler_in_flight",
			Help: "The number of handlers currently running.",
			ConstLabels: map[string]string{
				"service": "refresh-token",
				"tag":     "[auth]",
			},
		},
	)
)

func RefreshTokenInstrumentHandler(handler http.Handler) http.Handler {
	return promhttp.InstrumentHandlerInFlight(refreshTokenHandlerInFlight,
		promhttp.InstrumentHandlerDuration(refreshTokenHandlerDuration,
			handler,
		),
	)
}
