// Code generated by go-swagger/go-orusapi; DO NOT EDIT.

package operations

import (
	"net/http"

	"github.com/rs/zerolog"
)

func LogOperation(tag, operationID string) func(http.Handler) http.Handler {
	return func(next http.Handler) http.Handler {
		return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
			log := zerolog.Ctx(r.Context())

			log.UpdateContext(func(c zerolog.Context) zerolog.Context {
				return c.Str("api-tag", tag).Str("api-operation-id", operationID)
			})

			next.ServeHTTP(w, r)
		})
	}
}

func (o *RednerdAPI) LoggingInstrumentHandlers() {
	o.Init()

	o.handlers["POST"]["/v1/template/{account}"] = LogOperation(
		"template-management", "account-template-add",
	)(o.handlers["POST"]["/v1/template/{account}"])

	o.handlers["DELETE"]["/v1/template/{account}/{name}"] = LogOperation(
		"template-management", "account-template-delete",
	)(o.handlers["DELETE"]["/v1/template/{account}/{name}"])

	o.handlers["GET"]["/v1/template/{account}/{name}"] = LogOperation(
		"template-management", "account-template-get",
	)(o.handlers["GET"]["/v1/template/{account}/{name}"])

	o.handlers["GET"]["/v1/template/{account}"] = LogOperation(
		"template-management", "account-template-list",
	)(o.handlers["GET"]["/v1/template/{account}"])

	o.handlers["PUT"]["/v1/template/{account}/{name}"] = LogOperation(
		"template-management", "account-template-update",
	)(o.handlers["PUT"]["/v1/template/{account}/{name}"])

	o.handlers["POST"]["/v1/auth/authenticate"] = LogOperation(
		"auth", "authenticate",
	)(o.handlers["POST"]["/v1/auth/authenticate"])

	o.handlers["POST"]["/v1/auth/forgot-password"] = LogOperation(
		"auth", "forgot-password",
	)(o.handlers["POST"]["/v1/auth/forgot-password"])

	o.handlers["POST"]["/v1/auth/logout"] = LogOperation(
		"auth", "logout",
	)(o.handlers["POST"]["/v1/auth/logout"])

	o.handlers["POST"]["/v1/auth/refresh_token"] = LogOperation(
		"auth", "refresh-token",
	)(o.handlers["POST"]["/v1/auth/refresh_token"])

	o.handlers["POST"]["/v1/auth/register"] = LogOperation(
		"auth", "register",
	)(o.handlers["POST"]["/v1/auth/register"])

	o.handlers["POST"]["/v1/render"] = LogOperation(
		"rendering", "render",
	)(o.handlers["POST"]["/v1/render"])

	o.handlers["GET"]["/v1/template/{account}/{id}/render"] = LogOperation(
		"rendering", "render-one",
	)(o.handlers["GET"]["/v1/template/{account}/{id}/render"])

	o.handlers["GET"]["/v1/renderlogs/{period}"] = LogOperation(
		"admin", "renderlogs",
	)(o.handlers["GET"]["/v1/renderlogs/{period}"])

	o.handlers["POST"]["/v1/auth/reset-password"] = LogOperation(
		"auth", "reset-password",
	)(o.handlers["POST"]["/v1/auth/reset-password"])

	o.handlers["GET"]["/v1/template"] = LogOperation(
		"template-management", "template-list",
	)(o.handlers["GET"]["/v1/template"])

	o.handlers["POST"]["/v1/template/{account}/{id}/render"] = LogOperation(
		"rendering", "template-render",
	)(o.handlers["POST"]["/v1/template/{account}/{id}/render"])

	o.handlers["POST"]["/v1/varlist"] = LogOperation(
		"template-management", "template-varlist",
	)(o.handlers["POST"]["/v1/varlist"])

	o.handlers["POST"]["/v1/user"] = LogOperation(
		"user-management", "user-add",
	)(o.handlers["POST"]["/v1/user"])

	o.handlers["POST"]["/v1/user/{username}/apikey"] = LogOperation(
		"user-management", "user-apikey-add",
	)(o.handlers["POST"]["/v1/user/{username}/apikey"])

	o.handlers["DELETE"]["/v1/user/{username}/apikey/{name}"] = LogOperation(
		"user-management", "user-apikey-delete",
	)(o.handlers["DELETE"]["/v1/user/{username}/apikey/{name}"])

	o.handlers["GET"]["/v1/user/{username}/apikey"] = LogOperation(
		"user-management", "user-apikey-list",
	)(o.handlers["GET"]["/v1/user/{username}/apikey"])

	o.handlers["DELETE"]["/v1/user/{username}"] = LogOperation(
		"user-management", "user-delete",
	)(o.handlers["DELETE"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/user/{username}"] = LogOperation(
		"user-management", "user-get",
	)(o.handlers["GET"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/user"] = LogOperation(
		"user-management", "user-list",
	)(o.handlers["GET"]["/v1/user"])

	o.handlers["DELETE"]["/v1/user/{username}/password"] = LogOperation(
		"user-management", "user-password-delete",
	)(o.handlers["DELETE"]["/v1/user/{username}/password"])

	o.handlers["POST"]["/v1/user/{username}/password"] = LogOperation(
		"user-management", "user-password-set",
	)(o.handlers["POST"]["/v1/user/{username}/password"])

	o.handlers["PUT"]["/v1/user/{username}"] = LogOperation(
		"user-management", "user-update",
	)(o.handlers["PUT"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/auth/userinfo"] = LogOperation(
		"auth", "userinfo",
	)(o.handlers["GET"]["/v1/auth/userinfo"])

}
