// Code generated by go-swagger/go-orusapi;; DO NOT EDIT.

package operations

import (
	"github.com/prometheus/client_golang/prometheus"
	"orus.io/orus-io/rednerd/restapi/operations/admin"
	"orus.io/orus-io/rednerd/restapi/operations/auth"
	"orus.io/orus-io/rednerd/restapi/operations/rendering"
	"orus.io/orus-io/rednerd/restapi/operations/template_management"
	"orus.io/orus-io/rednerd/restapi/operations/user_management"
)

func (o *RednerdAPI) PrometheusInstrumentHandlers() {
	o.Init()

	o.handlers["POST"]["/v1/template/{account}"] = template_management.AccountTemplateAddInstrumentHandler(
		o.handlers["POST"]["/v1/template/{account}"])

	o.handlers["DELETE"]["/v1/template/{account}/{name}"] = template_management.AccountTemplateDeleteInstrumentHandler(
		o.handlers["DELETE"]["/v1/template/{account}/{name}"])

	o.handlers["GET"]["/v1/template/{account}/{name}"] = template_management.AccountTemplateGetInstrumentHandler(
		o.handlers["GET"]["/v1/template/{account}/{name}"])

	o.handlers["GET"]["/v1/template/{account}"] = template_management.AccountTemplateListInstrumentHandler(
		o.handlers["GET"]["/v1/template/{account}"])

	o.handlers["PUT"]["/v1/template/{account}/{name}"] = template_management.AccountTemplateUpdateInstrumentHandler(
		o.handlers["PUT"]["/v1/template/{account}/{name}"])

	o.handlers["POST"]["/v1/auth/authenticate"] = auth.AuthenticateInstrumentHandler(
		o.handlers["POST"]["/v1/auth/authenticate"])

	o.handlers["POST"]["/v1/auth/forgot-password"] = auth.ForgotPasswordInstrumentHandler(
		o.handlers["POST"]["/v1/auth/forgot-password"])

	o.handlers["POST"]["/v1/auth/logout"] = auth.LogoutInstrumentHandler(
		o.handlers["POST"]["/v1/auth/logout"])

	o.handlers["POST"]["/v1/auth/refresh_token"] = auth.RefreshTokenInstrumentHandler(
		o.handlers["POST"]["/v1/auth/refresh_token"])

	o.handlers["POST"]["/v1/auth/register"] = auth.RegisterInstrumentHandler(
		o.handlers["POST"]["/v1/auth/register"])

	o.handlers["POST"]["/v1/render"] = rendering.RenderInstrumentHandler(
		o.handlers["POST"]["/v1/render"])

	o.handlers["GET"]["/v1/template/{account}/{id}/render"] = rendering.RenderOneInstrumentHandler(
		o.handlers["GET"]["/v1/template/{account}/{id}/render"])

	o.handlers["GET"]["/v1/renderlogs/{period}"] = admin.RenderlogsInstrumentHandler(
		o.handlers["GET"]["/v1/renderlogs/{period}"])

	o.handlers["POST"]["/v1/auth/reset-password"] = auth.ResetPasswordInstrumentHandler(
		o.handlers["POST"]["/v1/auth/reset-password"])

	o.handlers["GET"]["/v1/template"] = template_management.TemplateListInstrumentHandler(
		o.handlers["GET"]["/v1/template"])

	o.handlers["POST"]["/v1/template/{account}/{id}/render"] = rendering.TemplateRenderInstrumentHandler(
		o.handlers["POST"]["/v1/template/{account}/{id}/render"])

	o.handlers["POST"]["/v1/varlist"] = template_management.TemplateVarlistInstrumentHandler(
		o.handlers["POST"]["/v1/varlist"])

	o.handlers["POST"]["/v1/user"] = user_management.UserAddInstrumentHandler(
		o.handlers["POST"]["/v1/user"])

	o.handlers["POST"]["/v1/user/{username}/apikey"] = user_management.UserApikeyAddInstrumentHandler(
		o.handlers["POST"]["/v1/user/{username}/apikey"])

	o.handlers["DELETE"]["/v1/user/{username}/apikey/{name}"] = user_management.UserApikeyDeleteInstrumentHandler(
		o.handlers["DELETE"]["/v1/user/{username}/apikey/{name}"])

	o.handlers["GET"]["/v1/user/{username}/apikey"] = user_management.UserApikeyListInstrumentHandler(
		o.handlers["GET"]["/v1/user/{username}/apikey"])

	o.handlers["DELETE"]["/v1/user/{username}"] = user_management.UserDeleteInstrumentHandler(
		o.handlers["DELETE"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/user/{username}"] = user_management.UserGetInstrumentHandler(
		o.handlers["GET"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/user"] = user_management.UserListInstrumentHandler(
		o.handlers["GET"]["/v1/user"])

	o.handlers["DELETE"]["/v1/user/{username}/password"] = user_management.UserPasswordDeleteInstrumentHandler(
		o.handlers["DELETE"]["/v1/user/{username}/password"])

	o.handlers["POST"]["/v1/user/{username}/password"] = user_management.UserPasswordSetInstrumentHandler(
		o.handlers["POST"]["/v1/user/{username}/password"])

	o.handlers["PUT"]["/v1/user/{username}"] = user_management.UserUpdateInstrumentHandler(
		o.handlers["PUT"]["/v1/user/{username}"])

	o.handlers["GET"]["/v1/auth/userinfo"] = auth.UserinfoInstrumentHandler(
		o.handlers["GET"]["/v1/auth/userinfo"])

}

func init() {
	reg := prometheus.WrapRegistererWith(prometheus.Labels{
		"api_name":    "Rednerd",
		"api_title":   "Rednerd API",
		"api_version": "0.7.0",
	}, prometheus.DefaultRegisterer)

	admin.RegisterPrometheus(reg)
	auth.RegisterPrometheus(reg)
	rendering.RegisterPrometheus(reg)
	template_management.RegisterPrometheus(reg)
	user_management.RegisterPrometheus(reg)
}
