package tests

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestVarlist(t *testing.T) {
	tester := NewAPITester(t, nil)
	defer tester.Close()

	defer tester.Logout()
	tester.Login("admin", "admin")

	tester.CreateUser("janedoe", "janedoe")
	tester.Login("janedoe", "janedoe")

	t.Run("mustache", func(t *testing.T) {
		defer tester.SetT(t)()
		var result []string
		tester.MustPostJSON(
			"/api/v1/varlist",
			JSONObj{
				"language":    "mustache",
				"produces":    "text/mjml",
				"body-format": "text",
				"body":        "<mjml> <mj-body> <mj-section> <mj-column> <mj-text>hello {{name}}</mj-text> </mj-column> </mj-section> </mj-body> </mjml>",
			},
			&result,
		)

		assert.Equal(t, []string{
			"name",
		}, result)
	})
}
